import Flutter
import UIKit
import PayFortSDK
public class SwiftPayfortPlugin: NSObject, FlutterPlugin {
    //var window: UIWindow?
    var navigationController: UINavigationController?
    var controller : FlutterViewController?
    var payFort : PayFortController?
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "payfort_plugin", binaryMessenger: registrar.messenger())
    let instance = SwiftPayfortPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
    
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    if call.method == "getID" {
        result(self.getId())
        
    } else if call.method == "initPayFort" {
//        let frame = CGRect.init(x: 0, y: UIScreen.main.bounds.height - 60, width: UIScreen.main.bounds.width, height: 60)
//            window = UIWindow.init(frame: frame)
        controller = self.getRootController() as! FlutterViewController
        guard let args = call.arguments as? Dictionary<String, String> else { return }
        let token = args["sdkToken"]
        let merchantRef = args["merchantRef"]
        let name = args["name"]
        let lang = args["lang"]
        let command = args["command"]
        let amount = args["amount"]
        let email = args["email"]
        let currency = args["currency"]
        let mode = args["mode"]
        
    
        if mode == "0" {
            self.payFort = PayFortController.init(enviroment: .sandBox)
            //print("test")

        }else{
            self.payFort = PayFortController.init(enviroment: .production)
            //print("production")
        }
        


        let request: NSMutableDictionary = .init()
         request.setValue(amount, forKey: "amount")
         request.setValue(command, forKey: "command")
         request.setValue(currency, forKey: "currency")
         request.setValue(email, forKey: "customer_email")
         request.setValue(lang, forKey: "language")
         request.setValue(merchantRef, forKey: "merchant_reference")
         request.setValue(token , forKey: "sdk_token")

        //print("amount ios"+amount!+currency!)
        self.payFort!.isShowResponsePage = true
        self.payFort!.callPayFort(withRequest: request as! [String : String] ,
                            currentViewController: (UIApplication.shared.keyWindow?.rootViewController)!,
                            success: { (requestDic, responeDic) in
                                print("success")
                                result(responeDic)
        },
                            canceled: { (requestDic, responeDic) in
                            print("cancelled")

                                result(responeDic)
        },
                            faild: { (requestDic, responeDic, message) in
                               print("failed "+message)
 
                                result(message)
        })
        
    }

  }
func getId() -> String {
    UIDevice.current.identifierForVendor?.uuidString ?? UUID().uuidString
    
}
    
    func getRootController() -> UIViewController {
           let keyWindow = UIApplication.shared.windows.first(where: { $0.isKeyWindow }) ?? UIApplication.shared.windows.first
        let topController = (keyWindow?.rootViewController)!
           return topController
       }
}
